signature Processor where {
import Assert;
		
import ConfigReg;
		   
import Counter;
		 
import FIFOF_;
		
import FIFOF;
	       
import FIFO;
	      
import Inout;
	       
import List;
	      
import BFIFO;
	    
import Clocks;
		
import ListN;
	       
import Monad;
	       
import PrimArray;
		   
import RWire;
	       
import RegFile;
		 
import SFIFO;
	    
import Vector;
		
import Connectable;
		     
import GetPut;
		
import ClientServer;
		      
import Trace;
	    
import MemTypes;
	       
import ProcTypes;
		
import BRegFile;
	       
import BranchPred;
		 
interface (Processor.ProcStats :: *) = {
    Processor.num_cycles :: GetPut.Get ProcTypes.Stat;
    Processor.num_inst :: GetPut.Get ProcTypes.Stat
};
 
instance Processor Prelude.PrimMakeUndefined Processor.ProcStats;
								      
instance Processor Prelude.PrimDeepSeqCond Processor.ProcStats;
								    
instance Processor Prelude.PrimMakeUninitialized Processor.ProcStats;
									  
interface (Processor.CPUToHost :: *) = {
    Processor.cpuToHost :: Prelude.Int 32 -> Prelude.Bit 32 {-# arg_names = [req] #-}
};
 
instance Processor Prelude.PrimMakeUndefined Processor.CPUToHost;
								      
instance Processor Prelude.PrimDeepSeqCond Processor.CPUToHost;
								    
instance Processor Prelude.PrimMakeUninitialized Processor.CPUToHost;
									  
interface (Processor.Proc :: *) = {
    Processor.dmem_client :: ClientServer.Client MemTypes.DataReq MemTypes.DataResp;
    Processor.imem_client :: ClientServer.Client MemTypes.InstReq MemTypes.InstResp;
    Processor.statsEn_get :: GetPut.Get Prelude.Bool;
    Processor.stats :: Processor.ProcStats;
    Processor.tohost :: Processor.CPUToHost
};
 
instance Processor Prelude.PrimMakeUndefined Processor.Proc;
								 
instance Processor Prelude.PrimDeepSeqCond Processor.Proc;
							       
instance Processor Prelude.PrimMakeUninitialized Processor.Proc;
								     
data (Processor.Stage :: *) = Processor.PCgen () | Processor.Exec () | Processor.Writeback ();
											     
instance Processor Prelude.PrimMakeUndefined Processor.Stage;
								  
instance Processor Prelude.PrimDeepSeqCond Processor.Stage;
								
instance Processor Prelude.PrimMakeUninitialized Processor.Stage;
								      
instance Processor Prelude.Eq Processor.Stage;
						   
instance Processor Prelude.Bits Processor.Stage 2;
						       
interface (Processor.BRFile :: *) = {
    Processor.wr :: ProcTypes.Rindx ->
		    Prelude.Bit 32 -> Prelude.Action {-# arg_names = [rindx, data] #-};
    Processor.rd1 :: ProcTypes.Rindx -> Prelude.Bit 32 {-# arg_names = [rindx] #-};
    Processor.rd2 :: ProcTypes.Rindx -> Prelude.Bit 32 {-# arg_names = [rindx] #-}
};
 
instance Processor Prelude.PrimMakeUndefined Processor.BRFile;
								   
instance Processor Prelude.PrimDeepSeqCond Processor.BRFile;
								 
instance Processor Prelude.PrimMakeUninitialized Processor.BRFile;
								       
Processor.mkBRFile :: (Prelude.IsModule _m__ _c__) => _m__ Processor.BRFile;
										 
Processor.slt :: Prelude.Bit 32 -> Prelude.Bit 32 -> Prelude.Bit 32;
										     
Processor.sltu :: Prelude.Bit 32 -> Prelude.Bit 32 -> Prelude.Bit 32;
										      
Processor.rshft :: Prelude.Bit 32 -> Prelude.Bit 32;
							       
Processor.findwbf :: ProcTypes.Rindx -> ProcTypes.WBResult -> Prelude.Bool;
										
Processor.stall :: ProcTypes.Instr ->
		   SFIFO.SFIFO ProcTypes.WBResult ProcTypes.Rindx -> Prelude.Bool;
										       
Processor.mkProc :: (Prelude.IsModule _m__ _c__) => _m__ Processor.Proc
}
